<?php
if(!defined('PHPFOX')){
	define('PHPFOX', true);
}
if(!defined('PHPFOX_DS')){
	define('PHPFOX_DS', DIRECTORY_SEPARATOR);
}	
if(!defined('PHPFOX_DIR')){
	define('PHPFOX_DIR', dirname(dirname(dirname(dirname(__FILE__)))) . PHPFOX_DS);
}	
if(!defined('CACHE_PATH')){
	define('CACHE_PATH',PHPFOX_DIR . 'file/cache/');
}	

require_once(dirname(__FILE__) .'/requestRemote.php');
if (!function_exists('json_decode')){
    require_once('JSON.php');
}
class Topcmmchat_Service_Topcmmchat extends Phpfox_Service{	
	private $FLASHCHAT_TABLE = '123flashchat';
	public function validate_client($client_loc){
        $c_own_loc = 1;
		$swf = $client_loc . 'admin_123flashchat.swf';
		$headers =	topcmmRequestRemote::requestRemote($swf,0);
		if($headers){
			if(substr($headers, 9, 3) == '200'){
				$c_own_loc = 0;
			}
		}
        return $c_own_loc;
    }
    
	public function validate_data_api($data_api){
		$da = 1;
		if(topcmmRequestRemote::requestRemote($data_api)){
			$da = 0;
		}
		return $da;
	}

    public function getFcSettings(){
		$aRows = $this->database()->select('*')
			->from($this->FLASHCHAT_TABLE)
			->where('id = 1')
			->execute('getRows');
		$aRow = $aRows[0];
        return $aRow;
    }
    
    public function saveFcConfig($data){
    	$getvar = '';
		foreach ( $data as $key => $value){
			if($getvar){
				$getvar .= ", $key='".$value."'";
			}else{
				$getvar .= "$key='".$value."'";
			}
		}
		$sql = "UPDATE $this->FLASHCHAT_TABLE SET $getvar";	
    	$updates = $this->database()->query($sql);
		return $updates;
    }
    	
	public function addFcSlash($path){
		if(substr($path,-1,1) != "/" && !empty($path)){
			$path = $path."/";
		}
		return $path;
	}

	public function getFcValid($fcSetting){
		$c_server_loc = 1;
		if($fcSetting['fc_server_host']){
			if($fcSetting['fc_server_host'] == $_SERVER['SERVER_NAME']){
				$c_own_loc = $this->validate_client('http://'.$fcSetting['fc_server_host'].':'.$fcSetting['fc_server_port_h'].'/');
				if(!$c_own_loc){
					$c_server_loc = 0;
				}
			}
		}else{
			$c_own_loc = $this->validate_client('http://'.$_SERVER['SERVER_NAME'].':'.$fcSetting['fc_server_port_h'].'/');
			if(!$c_own_loc){
				$c_server_loc = 0;
			}
		}
		return $c_server_loc;
	}

	public function getChatUrl(){
        $fcsetting = $this->getFcSettings();        
        switch($fcsetting['fc_extendserver']){
			case 0:
				if($fcsetting['fc_servertype'] != 1 && $fcsetting['fc_clienttype'] == 1){
					$clientname = '123flashchat.swf';
				}else{
					$clientname = 'htmlchat/123flashchat.html';
				}
				$url =  $fcsetting['fc_client_loc'] . $clientname . "?init_host=" . $fcsetting['fc_server_host'] . "&init_port=" . $fcsetting['fc_server_port'] ;
				$url .= ($fcsetting['fc_server_host_s'] ? "&init_host_s=" . $fcsetting['fc_server_host_s'] : "") . ($fcsetting['fc_server_port_s'] ? "&init_port_s=" . $fcsetting['fc_server_port_s'] : "");
				$url .= ($fcsetting['fc_server_host_h'] ? "&init_host_h=" . $fcsetting['fc_server_host_h'] : "") . ($fcsetting['fc_server_port_h'] ? "&init_port_h=" . $fcsetting['fc_server_port_h'] : "");
				break;
			case 1:
				if($fcsetting['fc_clienttype'] == 1){
					$clientname = '123flashchat.swf';
				}else{
					$clientname = 'htmlchat/123flashchat.html';
				}
				$url = $fcsetting['fc_client_loc'] . $clientname . "?init_host=" . $fcsetting['fc_server_host'] . "&init_port=" . $fcsetting['fc_server_port'];
				$url .= ($fcsetting['fc_server_host_s'] ? "&init_host_s=" . $fcsetting['fc_server_host_s'] : "") . ($fcsetting['fc_server_port_s'] ? "&init_port_s=" . $fcsetting['fc_server_port_s'] : "");
				$url .= ($fcsetting['fc_server_host_h'] ? "&init_host_h=" . $fcsetting['fc_server_host_h'] : "") . ($fcsetting['fc_server_port_h'] ? "&init_port_h=" . $fcsetting['fc_server_port_h'] : "");
				$url .= "&init_group=" . $fcsetting['fc_group'];
				break;
			case 2:
				$url = "http://free.123flashchat.com/js.php?room=" . urlencode($fcsetting['fc_room']) . "&skin="  . $fcsetting['fc_client_skin'] . "&lang="  . $fcsetting['fc_client_lang'];
				return $url;
				break;
		}
		if(Phpfox::isUser() && $user = $this->getUser()){
			$url .= '&init_user=' . $user['full_name'] . '&init_password=' . $user['password'];
		}
		if (!empty($_GET['room'])){
			$url .= "&init_room=" . $_GET['room'];
		}
		return $url;
    }

	public function getChatRooms($fcsetting){
        $opts = array('http'=>array('timeout'=>3,));
		$context = stream_context_create($opts);
        $data = topcmmRequestRemote::requestRemote(CACHE_PATH."rooms.js",1);
		$rooms_json = substr($data,10);
	    if ((time() > substr($data,0,10)) || !$rooms_json){
	    	$server = $fcsetting['fc_extendserver'];
	        switch ($server) {
	            case 0:
	        	    $room_js = $fcsetting['fc_api_url'] . "rooms.js";
	        	    break;
	            case 1:
	        	    $room_js = $fcsetting['fc_api_url'] . "rooms.js?group=" . $fcsetting['fc_group'];
	        	    break;
	            case 2:
	            	$room_js = '';
	            	break;
	        }
	        if($room_js){
	        	if($rs = topcmmRequestRemote::requestRemote($room_js, 1)){
		        	$rooms_json = substr($rs,10,-1);
		        }
	        }	        
	        @file_put_contents(CACHE_PATH."rooms.js",(time() + 120) . $rooms_json);
	    }
	    return json_decode($rooms_json, true);
    }
    
	public function getChatUsers($fcsetting){
        $opts = array('http'=>array('timeout'=>2,));
		$context = stream_context_create($opts);
		$data =  topcmmRequestRemote::requestRemote(CACHE_PATH."users.js",1);
		$users_json = substr($data,10);
	    if ((time() > substr($data,0,10)) || !$users_json){
	    	$server =  $fcsetting['fc_extendserver'];
	        switch ($server){
	            case 0:
	                $rooms = self::getChatRooms($fcsetting);
	                $users = array();
	                if($rooms && is_array($rooms)){
		                foreach ($rooms as $room){
		                    $user_js = $fcsetting['fc_api_url'] . "roomonlineusers.js?roomid=" . $room['id'];
		                    if($rs = topcmmRequestRemote::requestRemote($user_js, 1)){
		                        $users = array_merge($users, json_decode(substr($rs,20,-1),true));
		                    }
		                }
	                }
	                $users_json = json_encode($users);
	        	    break;
	            case 1:
	        	    $user_js = $fcsetting['fc_api_url'] . "roomonlineusers.js?group=" . $fcsetting['fc_group'];
	        	    if($rs = topcmmRequestRemote::requestRemote($user_js, 1)){
	        	        $users_json = substr($rs,20,-1);
	        	    }
	        	    break;
	        	case 2:
	        		$users = array();       		
	        	    $user_js = "http://free.123flashchat.com/freeroomuser.php?roomname=" . $fcsetting['fc_room'];
	        	    if($rs = topcmmRequestRemote::requestRemote($user_js, 1)){
                        preg_match("/document.write\('(.*)'\);/",$rs,$matches);
	    	            foreach (explode(',', $matches[1]) as $user){
	    	                $users[] = array('name' => $user);
	    	            }
	    	        }
	    	        $users_json = json_encode($users);
	    	        break;
	        }
	        $users_json = self::filterUserList($users_json);
	        @file_put_contents(CACHE_PATH."users.js",(time() + 120) . $users_json);
	    }
	    return json_decode($users_json, true);
    }

	private function filterUserList($users_json){
		$user_array =  json_decode($users_json,true);
		$user_regroup_array = array();
		$user_tmp_array = array();
		foreach($user_array as $key => $val){
			if (!in_array($val['name'], $user_tmp_array)){
				$user_tmp_array[] = $val['name'];
				$user_regroup_array[$key] = $user_array[$key];
			}
		}
		return json_encode($user_regroup_array);
	}
    
	public function getChatStatus($fcsetting){
        $data = topcmmRequestRemote::requestRemote(CACHE_PATH."status.js",1);
	    $status_json = substr($data,10);
	    if ((time() > substr($data,0,10)) || !$status_json){
	        $server =  $fcsetting['fc_extendserver'];
	        switch ($server){
	            case 0:
	        	    $status_js = $fcsetting['fc_api_url'] . "online.js";
	        	    if($rs = topcmmRequestRemote::requestRemote($status_js, 1)){
	        	        $status_json = substr($rs,11,-1);
	        	    }
	        	    break;
	        	case 1:
	        	    $status_js = $fcsetting['fc_api_url'] . "online.js?group=" . $fcsetting['fc_group'];
	        	    if($rs = topcmmRequestRemote::requestRemote($status_js,1)){
	        	        $status_json = substr($rs,11,-1);
	        	    }
	        	    break;
	        	case 2:
	        	    $status_js = "http://free.123flashchat.com/freeroomnum.php?roomname=" . $fcsetting['fc_room'];
	        	    if($rs = topcmmRequestRemote::requestRemote($status_js,1)){
                        preg_match("/document.write\('(.*)'\);/",$rs,$matches);
	        	        $status['ln'] = $matches[1];					
	        	        $status['rn'] = '';
	        	        $status['cn'] = '';
	        	        $status_json = json_encode($status);
	        	    }
	        	    break;
	        }
			@file_put_contents(CACHE_PATH."status.js",(time() + 120) . $status_json);
	    }
		return json_decode($status_json,true);
    }
    
	public function getUser(){
        $user = array();
        if (Phpfox::isUser()){
            $u = Phpfox::getLib('phpfox.database')
                    ->select('*')
                    ->from(Phpfox::getT('user'))
                    ->where('user_id = ' . Phpfox::getUserId())
                    ->execute('getRows');
            $user = $u[0];
        }
        return $user;
    }
    
    public function getUserInfoByNameEmail($username){
    	$user = array();
		$u = Phpfox::getLib('phpfox.database')
			->select('*')
			->from(Phpfox::getT('user'))
			->where('full_name = "' . $username . '" or email = "'.$username.'"')
			->execute('getRows');
		if(!empty($u[0])){
			$user = $u[0];
		}            
        return $user;
    }
    
    public function getUserCountry($country_ico){
    	$country = array();
		$c = Phpfox::getLib('phpfox.database')
			->select('*')
			->from(Phpfox::getT('country'))
			->where('country_iso = "' . $country_ico . '"')
			->execute('getRows');
            $country = $c[0];
        return $country;
    }
    
    public function getUserPassword($password){
    	$p = Phpfox::getLib('phpfox.database')
    		->escape($password);
    	return $p;
    }

    public function getValid($fcSetting){
    	$c_server_loc = 1;
		if($fcSetting['fc_server_host']){
			if($fcSetting['fc_server_host'] == $_SERVER['SERVER_NAME']){
				$c_own_loc = $this->validate_client('http://'.$fcSetting['fc_server_host'].':'.$fcSetting['fc_server_port_h'].'/');
				if(!$c_own_loc){
					$c_server_loc = 0;
				}
			}
		}else{
			$c_own_loc = $this->validate_client('http://'.$_SERVER['SERVER_NAME'].':'.$fcSetting['fc_server_port_h'].'/');
			if(!$c_own_loc){
				$c_server_loc = 0;
			}
		}
		return $c_server_loc;
    }
}